> ## Documentation Index
> Fetch the complete documentation index at: https://ona.com/docs/llms.txt
> Use this file to discover all available pages before exploring further.

# Update Task

> Updates an automation task configuration.

`Unary` · [`Environment Automations`](/docs/api-reference/generated/environment-automation/overview)

Updates an automation task configuration.

Use this method to:

* Modify task commands
* Update task triggers
* Change dependencies
* Adjust execution settings

### Examples

* Update command:

  Changes the task's command.

  ```yaml theme={null}
  id: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  spec:
    command: "npm run test:coverage"
  ```

* Update triggers:

  Modifies when the task runs.

  ```yaml theme={null}
  id: "d2c94c27-3b76-4a42-b88c-95a85e392c68"
  metadata:
    triggeredBy:
      trigger:
        - postEnvironmentStart: true
  ```

## Endpoint

```text theme={null}
POST /api/gitpod.v1.EnvironmentAutomationService/UpdateTask
```

Send a Bearer token as described in [Authentication](/docs/api-reference#authenticate-requests). If your organization uses a custom management-plane domain, replace `https://app.ona.com` with that domain.

## Request example

<CodeGroup>
  ```bash cURL theme={null}
  export ONA_HOST=https://app.ona.com
  export ONA_API_KEY=<your-token>

  curl --request POST \
    --url "$ONA_HOST/api/gitpod.v1.EnvironmentAutomationService/UpdateTask" \
    --header "Authorization: Bearer $ONA_API_KEY" \
    --header "Content-Type: application/json" \
    --data '{
    "id": "<id>"
  }'
  ```

  ```python Python theme={null}
  import gitpod.v1.environment_automation_pb2 as environment_automation_pb2
  from ona_sdk import create_client_from_env

  ona = create_client_from_env()
  request = environment_automation_pb2.UpdateTaskRequest(
      id="<id>",
  )
  response = ona.services.environment_automation.update_task(request)
  print(response)
  ```

  ```typescript TypeScript theme={null}
  import { create } from "@bufbuild/protobuf";
  import { createClientFromEnv } from "@gitpod/sdk";
  import { UpdateTaskRequestSchema } from "@gitpod/sdk/gitpod/v1/environment_automation_pb";

  async function main() {
    const ona = createClientFromEnv();
    const request = create(UpdateTaskRequestSchema, {
      id: "<id>",
    });
    const response = await ona.services.environmentAutomation.updateTask(request);
    console.log(response);
  }

  main().catch(console.error);
  ```

  ```go Go theme={null}
  package main

  import (
  	"context"
  	"fmt"
  	"log"

  	"connectrpc.com/connect"
  	"github.com/gitpod-io/gitpod-sdk-go/sdk"
  	gitpodpb "github.com/gitpod-io/gitpod-sdk-go/v1"
  )

  func main() {
  	ona, err := sdk.NewFromEnv()
  	if err != nil {
  		log.Fatal(err)
  	}

  	request := connect.NewRequest(&gitpodpb.UpdateTaskRequest{
  		Id: "<id>",
  	})
  	response, err := ona.Services.EnvironmentAutomation.UpdateTask(context.Background(), request)
  	if err != nil {
  		log.Fatal(err)
  	}
  	fmt.Println(response.Msg)
  }
  ```

  ```json Request body theme={null}
  {
    "id": "<id>"
  }
  ```
</CodeGroup>

## Request

`gitpod.v1.UpdateTaskRequest`

| Field       | Type                                                              | Required | Description                                                                                                             |
| ----------- | ----------------------------------------------------------------- | -------- | ----------------------------------------------------------------------------------------------------------------------- |
| `id`        | string                                                            | No       | Constraints: `string.uuid=true`.                                                                                        |
| `metadata`  | [TaskMetadata](#type-gitpod-v1-update-task-request-task-metadata) | No       |                                                                                                                         |
| `spec`      | [TaskSpec](#type-gitpod-v1-update-task-request-task-spec)         | No       |                                                                                                                         |
| `dependsOn` | array of string                                                   | No       | dependencies specifies the IDs of the automations this task depends on. Constraints: `repeated.items.string.uuid=true`. |

## Response

`gitpod.v1.UpdateTaskResponse`

This message has no fields.

## Related types

<a id="type-gitpod-v1-environment-variable-item" />

<Accordion title="EnvironmentVariableItem">
  EnvironmentVariableItem represents an environment variable that can be set
  either from a literal value or from a secret reference.

  `gitpod.v1.EnvironmentVariableItem`

  | Field       | Type                      | Required | Description                                                             |
  | ----------- | ------------------------- | -------- | ----------------------------------------------------------------------- |
  | `name`      | string                    | No       | name is the environment variable name. Constraints: `string.min_len=1`. |
  | `value`     | string                    | No       | value is a literal string value.                                        |
  | `valueFrom` | EnvironmentVariableSource | No       | value\_from specifies a source for the value.                           |
</Accordion>

<a id="type-gitpod-v1-runs-on" />

<Accordion title="RunsOn">
  `gitpod.v1.RunsOn`

  | Field     | Type    | Required | Description |
  | --------- | ------- | -------- | ----------- |
  | `docker`  | Docker  | No       |             |
  | `machine` | Machine | No       |             |
</Accordion>

<a id="type-gitpod-v1-update-task-request-automation-trigger-update" />

<Accordion title="AutomationTriggerUpdate">
  `gitpod.v1.UpdateTaskRequest.AutomationTriggerUpdate`

  | Field     | Type                       | Required | Description |
  | --------- | -------------------------- | -------- | ----------- |
  | `trigger` | array of AutomationTrigger | No       |             |
</Accordion>

<a id="type-gitpod-v1-update-task-request-task-metadata" />

<Accordion title="TaskMetadata">
  `gitpod.v1.UpdateTaskRequest.TaskMetadata`

  | Field         | Type                                                                                     | Required | Description                      |
  | ------------- | ---------------------------------------------------------------------------------------- | -------- | -------------------------------- |
  | `name`        | string                                                                                   | No       | Constraints: `string.min_len=1`. |
  | `description` | string                                                                                   | No       |                                  |
  | `triggeredBy` | [AutomationTriggerUpdate](#type-gitpod-v1-update-task-request-automation-trigger-update) | No       |                                  |
</Accordion>

<a id="type-gitpod-v1-update-task-request-task-spec" />

<Accordion title="TaskSpec">
  `gitpod.v1.UpdateTaskRequest.TaskSpec`

  | Field                     | Type                                                                          | Required | Description |
  | ------------------------- | ----------------------------------------------------------------------------- | -------- | ----------- |
  | `command`                 | string                                                                        | No       |             |
  | `runsOn`                  | [RunsOn](#type-gitpod-v1-runs-on)                                             | No       |             |
  | `env`                     | array of [EnvironmentVariableItem](#type-gitpod-v1-environment-variable-item) | No       |             |
  | `prebuildRequiresSuccess` | boolean                                                                       | No       |             |
</Accordion>
